#!/usr/bin/perl -w
#usage: select.pl infile outfile
#Will store the columns checked with a 'p' or 't'  in outfile
#p's are stored first.
use parse_string;
($infile,$outfile)=@ARGV;
$outfile='selected.dat' unless defined($outfile);
open IN,"<$infile";
open OUT,">$outfile";
print OUT "\# select.pl selected data from $infile\n\# $infile had these comments:\n";
@p=();
@t=();
$n=0;
$nrec=0;
while ($line=<IN>){
  if ($line=~m/^\s*\#/){
    print OUT $line;
    if ($line=~s/^\s*\#c//){
      ($i,$name,$ch)=&parse_string($line);    
      print "no characters to process in: $line\n" unless defined($ch);
      @p=(@p,$i) if defined($ch) and $ch=~m/p/; 
      @t=(@t,$i) if defined($ch) and $ch=~m/t/; 
      $names{$i}=$name;
    }
  }
  else{
    $nrec++;
    if ($nrec==1) {
      $lenp=@p;
      $lent=@t;
      print "making $outfile with input vector length $lenp and output vector length $lent \n";
      $n=0;
      print OUT "\# this is what was selected by select.pl:\n";
      print OUT "\# input vector p of length $lenp consists of:\n";
      for $i (@p) {
        $n++;
        print OUT "\# $n $i $names{$i}\n";
      }
      print OUT "\# target vector t of $lent consists of:\n";
      for $i (@t) {
        $n++;
        print OUT "\# $n $i $names{$i}\n";
      }
    }
    $out='';
    chomp($line);
    $line=~s/^\s+//;
    $line=~s/\s+$//;
    @v=split /\s+/,$line;
    for $i (@p) {
      $out.="$v[$i-1]  ";
    }
    for $i (@t) {
      $out.="$v[$i-1]  ";
    }
    $out=~s/\s+$//;
    print OUT $out,"\n";
  }
}
